Index: /trunk/gli/classes/dictionary_es.properties
===================================================================
--- /trunk/gli/classes/dictionary_es.properties	(revision 10002)
+++ /trunk/gli/classes/dictionary_es.properties	(revision 10003)
@@ -242,4 +242,6 @@
 CDM.SearchTypeManager.Add_Tooltip:Permite el tipo especificado de bÃºsqueda en esta colecciÃ³n
 CDM.SearchTypeManager.Assigned:Tipos de bÃºsqueda asignados actualmente
+# -- Missing translation: CDM.SearchTypeManager.BuildType_Selection
+# -- Missing translation: CDM.SearchTypeManager.BuildType_Selection_Tooltip
 CDM.SearchTypeManager.Enable:Permitir bÃºsquedas avanzadas
 CDM.SearchTypeManager.Instructions:Definir el tipo de bÃºsqueda es una funciÃ³n avanzada que sÃ³lo estÃ¡ disponible cuando se marca el recuadro âPermitir bÃºsquedas avanzadasâ. Una vez que se activa, otros controles para seleccionar y cambiar el orden de los tipos de bÃºsqueda tambiÃ©n estÃ¡n disponibles. Seleccione un tipo de bÃºsqueda del cuadro de utilerÃ­as y haga click en âAÃ±adir tipo de bÃºsquedaâ para agregarlo. Seleccione de la lista un tipo de bÃºsqueda existente y use los botones âMover arribaâ y âMover abajoâ para cambiar su orden, o el botÃ³n âEliminar tipo de bÃºsquedaâ para quitarlo de la lista.\n\n Los tipos de bÃºsqueda especifican el tipo de bÃºsqueda con el que contarÃ¡n las interfaces: formas, bÃºsqueda por campos y/o bÃºsqueda de sÃ³lo texto. El orden es importante, ya que el primero se usarÃ¡ por omisiÃ³n para la pÃ¡gina de bÃºsqueda inicial.\n\n Asimismo es importante recordar que al activar los diferentes tipos de bÃºsqueda, la apariencia de la pantalla de Ãndices tambiÃ©n cambia. La bÃºsqueda por campos es una funciÃ³n reciente de Greenstone y por lo tanto requiere de informaciÃ³n diferente. Cuando se active la funciÃ³n de tipos de bÃºsqueda todos los Ã­ndices se modificarÃ¡n para que sean vÃ¡lidos de acuerdo al nuevo esquema, mientras que al desactivar los tipos de bÃºsqueda la Interfaz de la Biblioteca Digital harÃ¡ lo posible por convertir los nuevos Ã­ndices de regreso al estilo anterior, aunque puede ser que no siempre tenga Ã©xito, en cuyo caso los Ã­ndices se eliminarÃ¡n. De cualquier manera, una copia de la lÃ­nea de comando del Ã­ndice original estarÃ¡ disponible como comentario en el archivo de configuraciÃ³n.
@@ -416,6 +418,8 @@
 EnrichPane.Accumulate_Tooltip:Agrega este valor al elemento de metadato seleccionado
 EnrichPane.AutoMessage:Este elemento, {0}, pertenece al conjunto de metadatos de Greenstone, el cual representa metadatos que normalmente pueden extraerse automÃ¡ticamente. Para saber quÃ© metadatos {0} pueden extraerse, construya una colecciÃ³n por medio de la pantalla âCrearâ.
+# -- Missing translation: EnrichPane.ExistingValues
 EnrichPane.Expand:...
 EnrichPane.Expand_Tooltip:Edita el valor en un cuadro de texto mÃ¡s grande
+# -- Missing translation: EnrichPane.InheritedMetadataSelected
 EnrichPane.No_File:No se ha seleccionado ningÃºn archivo
 EnrichPane.No_Metadata:No hay metadatos disponibles
@@ -425,5 +429,4 @@
 EnrichPane.Remove:Eliminar
 EnrichPane.Remove_Tooltip:Elimina este valor del elemento de metadato seleccionado
-EnrichPane.Tree:Todos los valores anteriores
 EnrichPane.Value:Valor
 EnrichPane.Value_Field_Tooltip:Es el valor que se asignarÃ¡ al elemento de metadato seleccionado.
@@ -646,9 +649,4 @@
 Help.Contents:Contenido
 Help.Title:PÃ¡ginas de ayuda de la Interfaz de la Biblioteca Digital
-#
-#***** Inherited Metadata *****
-InheritedMetadata.Message:El archivo o carpeta seleccionada hereda algunos de sus metadatos de las carpetas que se encuentran arriba. Dichas entradas se indican por medio de un icono de carpeta y usted puede visitar la carpeta que contiene los metadatos haciendo click en este icono.
-InheritedMetadata.Title:Este archivo/carpeta tiene metadatos heredados
-#******************
 #
 #***** LockFileDialog *****
Index: /trunk/gli/classes/dictionary_lv.properties
===================================================================
--- /trunk/gli/classes/dictionary_lv.properties	(revision 10002)
+++ /trunk/gli/classes/dictionary_lv.properties	(revision 10003)
@@ -88,7 +88,5 @@
 CDM.ClassifierManager.Configure_Tooltip:IzvÄlÄtÄ klasifikÄtora opciju maiÅa
 CDM.ClassifierManager.Controls:RediÄ£ÄÅ¡anas Kontrole
-CDM.ClassifierManager.Instructions:Izmantojiet Å¡o paneli lai pevienotu, noÅemtu vai konfigurÄtu klasifikatorus jÅ«su kolekcijÄ. Lai pievienotu klasifikatoru, izvÄlieties to no kombinÄtÄ saraksta\n un noklikÅ¡Ä·iniet 'Pievienot Klasifikatoru'.Lai noÅemtu klasifikatoru, izvÄlieties to no nozÄ«mÄto klasifikatoru\n saraksta un noklikÅ¡Ä·iniet 'NoÅemt Klasifikatoru'.\nLai konfigurÄtu klasifikatoru, izvÄlieties to no nozÄ«mÄto klasifikatoru saraksta, un noklikÅ¡Ä·iniet 'KonfigurÄt Klasifikatoru'.\n\n
-Kad jÅ«s konfigurÄjiet klasifikatoru, tad  parÄdÄs rullslejas argumentu saraksts. \nIzvÄlieties (atÄŒaujot) argumentus no saraksta, kuriem jÅ«s vÄlaties
-ievadÄ«t vai izvÄlÄties nepiecieÅ¡amÄs vÄrtÄ«bas.
+CDM.ClassifierManager.Instructions:Izmantojiet Å¡o paneli lai pevienotu, noÅemtu vai konfigurÄtu klasifikatorus jÅ«su kolekcijÄ. Lai pievienotu klasifikatoru, izvÄlieties to no kombinÄtÄ saraksta\n un noklikÅ¡Ä·iniet 'Pievienot Klasifikatoru'. Lai noÅemtu klasifikatoru, izvÄlieties to no nozÄ«mÄto klasifikatoru\n saraksta un noklikÅ¡Ä·iniet 'NoÅemt Klasifikatoru'.\nLai konfigurÄtu klasifikatoru, izvÄlieties to no nozÄ«mÄto klasifikatoru saraksta, un noklikÅ¡Ä·iniet 'KonfigurÄt Klasifikatoru'.\n\nKad jÅ«s konfigurÄjiet klasifikatoru, tad parÄdÄs rullslejas argumentu saraksts. \nIzvÄlieties (atÄŒaujot) argumentus no saraksta, kuriem jÅ«s vÄlaties ievadÄ«t vai izvÄlÄties nepiecieÅ¡amÄs vÄrtÄ«bas.
 CDM.ClassifierManager.Remove:NoÅemt Klasifikatoru
 CDM.ClassifierManager.Remove_Tooltip:NoÅemt izvÄlÄto klasifikatoru no saraksta
@@ -107,6 +105,5 @@
 CDM.FormatManager.Insert:Iespraust
 CDM.FormatManager.Insert_Tooltip:Iespraust izvÄlÄto mainÄ«go formÄta komandÄ
-CDM.FormatManager.Instructions:Web lappas, kuras jÅ«s redzat izmantojot Greenstone, nav iepriekÅ¡ saglabÄtas, bet tiek Ä£enerÄtas 'lidojumÄ', t.i., to pieprasÄ«Å¡anas brÄ«dÄ«. FormÄta komandas tiek izmantotas, lai izmainÄ«tu Ä£enerÄto lapu izskatu. DaÅŸi ir pÄrslÄgi (switches), kuri kontrolÄ dokumenta vai tÄ daÄŒas atrÄdÄ«Å¡anu; citi ir vairÄk komplicÄti un prasa html kodus kÄ argumentus. \n
-Lai pievienotu formÄta komandu, izvÄlieties to no âpazÄ«mjuâ saraksta. Ja Äªsts/NeÄ«sts (True/False) opciju panelis parÄdÄs, tad izvÄlieties stÄvokli noklikÅ¡Ä·inot atbilstoÅ¡o pogu. Ja parÄdÄs panelis saturoÅ¡s kontroles âIetekmÄtÄ PazÄ«meâ un âRediÄ£Ät FormÄta Rindasâ, jums nepiecieÅ¡ams ievadÄ«t html tekstu. JÅ«s varat iekÄŒaut esoÅ¡os mainÄ«gos izvÄloties tos no saraksta.\n Kad jÅ«s esat veicis jÅ«su izmaiÅas, nospiediet âPievienot FormÄtuâ, lai to pievienotu konfigurÄcijas datnÄ (fails).\n NoÅemiet formÄta komandu, izvÄloties to no saraksta âNozÄ«mÄtÄs FormÄta Komandasâ un noklikÅ¡Ä·inot uz âNoÅemt FormÄtuâ pogas.
+CDM.FormatManager.Instructions:Web lappas, kuras jÅ«s redzat izmantojot Greenstone, nav iepriekÅ¡ saglabÄtas, bet tiek Ä£enerÄtas 'lidojumÄ', t.i., to pieprasÄ«Å¡anas brÄ«dÄ«. FormÄta komandas tiek izmantotas, lai izmainÄ«tu Ä£enerÄto lapu izskatu. DaÅŸi ir pÄrslÄgi (switches), kuri kontrolÄ dokumenta vai tÄ daÄŒas atrÄdÄ«Å¡anu; citi ir vairÄk komplicÄti un prasa html kodus kÄ argumentus.\nLai pievienotu formÄta komandu, izvÄlieties to no âpazÄ«mjuâ saraksta. Ja Äªsts/NeÄ«sts (True/False) opciju panelis parÄdÄs, tad izvÄlieties stÄvokli noklikÅ¡Ä·inot atbilstoÅ¡o pogu. Ja parÄdÄs panelis saturoÅ¡s kontroles âIetekmÄtÄ PazÄ«meâ un âRediÄ£Ät FormÄta Rindasâ, jums nepiecieÅ¡ams ievadÄ«t html tekstu. JÅ«s varat iekÄŒaut esoÅ¡os mainÄ«gos izvÄloties tos no saraksta.\n Kad jÅ«s esat veicis jÅ«su izmaiÅas, nospiediet âPievienot FormÄtuâ, lai to pievienotu konfigurÄcijas datnÄ (fails).\n NoÅemiet formÄta komandu, izvÄloties to no saraksta âNozÄ«mÄtÄs FormÄta Komandasâ un noklikÅ¡Ä·inot uz âNoÅemt FormÄtuâ pogas.
 CDM.FormatManager.Part:IetekmÄtÄ Komponente
 CDM.FormatManager.Part_Tooltip:IzvÄlÄtÄs pazÄ«mes aspekts, ko formatÄt
@@ -364,5 +361,4 @@
 CreatePane.Cancel_Build_Tooltip:PÄrtraukt kolekcijas formÄÅ¡anas procesu
 CreatePane.Import:Importa Opcijas
-
 CreatePane.Import_Tooltip:Opcijas kolekcijas formÄÅ¡anas datÅu convertÄcijas un metadatu pieÅ¡Ä·irÅ¡anas stadijÄ
 CreatePane.Import_Progress:Importa Progress
@@ -414,6 +410,5 @@
 #
 #***** DirectoryLevelMetadata *****
-DirectoryLevelMetadata.Message:JÅ«s taisÄties pieÅ¡Ä·irt 'mapes lÄ«meÅa' metadatus izvÄlÄtai mapei (vai mapÄm). Å os metadatus automÄtiski pÄrmantos visas datnes un mapes Å¡ajÄ mapÄ. TurklÄt Å¡ie metadata nevar bÅ«t vienkÄrÅ¡i noÅemti, bet tikai aizvietoti.
-Lai turpinÄtu Å¡o darbÄ«bu nospiediet 'OK'.
+DirectoryLevelMetadata.Message:JÅ«s taisÄties pieÅ¡Ä·irt 'mapes lÄ«meÅa' metadatus izvÄlÄtai mapei (vai mapÄm). Å os metadatus automÄtiski pÄrmantos visas datnes un mapes Å¡ajÄ mapÄ. TurklÄt Å¡ie metadata nevar bÅ«t vienkÄrÅ¡i noÅemti, bet tikai aizvietoti. Lai turpinÄtu Å¡o darbÄ«bu nospiediet 'OK'.
 DirectoryLevelMetadata.Title:Par mapes lÄ«meÅa metadatu pievienoÅ¡anu
 #********************
@@ -462,5 +457,4 @@
 WriteCDImagePrompt.Successful_Title:Eksports Pabeigts
 WriteCDImagePrompt.Title:Kolekcijas Eksports uz CD/DVD
-
 #************************
 #