Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SearchTypeManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SearchTypeManager.java	(revision 10007)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SearchTypeManager.java	(revision 10008)
@@ -50,6 +50,8 @@
  */
 public class SearchTypeManager
-    extends DOMProxyListModel {
-    
+    extends DOMProxyListModel
+{
+    static final private Dimension LABEL_SIZE = new Dimension(150, 25);
+
     static final public String[] SEARCH_TYPES = {  "plain" , "form"};
     static final public String[] BUILD_TYPES = {  "lucene", "mgpp" };
@@ -194,5 +196,5 @@
 
 	    build_type_combobox = new GComboBox(BUILD_TYPES);
-	    build_type_combobox.setPreferredSize(Utility.LABEL_SIZE);
+	    build_type_combobox.setPreferredSize(LABEL_SIZE);
 	    build_type_combobox.setBackgroundNonSelectionColor(Configuration.getColor("coloring.editable_background", false));
 	    build_type_combobox.setBackgroundSelectionColor(Configuration.getColor("coloring.collection_selection_background", false));
@@ -243,5 +245,5 @@
 	    Dictionary.registerText(search_type_label, "CDM.SearchTypeManager.SearchType_Selection");
 	    search_type_combobox = new GComboBox(SEARCH_TYPES);
-	    search_type_combobox.setPreferredSize(Utility.LABEL_SIZE);
+	    search_type_combobox.setPreferredSize(LABEL_SIZE);
 	    search_type_combobox.setBackgroundNonSelectionColor(Configuration.getColor("coloring.editable_background", false));
 	    search_type_combobox.setBackgroundSelectionColor(Configuration.getColor("coloring.collection_selection_background", false));
Index: /trunk/gli/src/org/greenstone/gatherer/gui/DownloadProgressBar.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gui/DownloadProgressBar.java	(revision 10007)
+++ /trunk/gli/src/org/greenstone/gatherer/gui/DownloadProgressBar.java	(revision 10008)
@@ -45,9 +45,12 @@
 import org.greenstone.gatherer.collection.DownloadJob;
 import org.greenstone.gatherer.util.AppendLineOnlyFileDocument;
-import org.greenstone.gatherer.util.Utility;
+
 
 public class DownloadProgressBar
     extends JPanel 
     implements ActionListener {
+
+    static final private Dimension MINIMUM_BUTTON_SIZE = new Dimension(100, 25);
+    static final private Dimension PROGRESS_BAR_SIZE = new Dimension(580,65);
 
     private boolean simple = false;
@@ -127,5 +130,5 @@
 	stop_start_button.addActionListener(this);
 	stop_start_button.addActionListener(owner);
-	stop_start_button.setMinimumSize(Utility.MINIMUM_BUTTON_SIZE);
+	stop_start_button.setMinimumSize(MINIMUM_BUTTON_SIZE);
 	stop_start_button.setMnemonic(KeyEvent.VK_P);
 	stop_start_button.setEnabled(true);
@@ -136,5 +139,5 @@
 	log_button.addActionListener(this);
 	log_button.setEnabled(false);
-	log_button.setMinimumSize(Utility.MINIMUM_BUTTON_SIZE);
+	log_button.setMinimumSize(MINIMUM_BUTTON_SIZE);
 	log_button.setMnemonic(KeyEvent.VK_L);
 	Dictionary.registerBoth(log_button, "Mirroring.DownloadJob.Log", "Mirroring.DownloadJob.Log_Tooltip");
@@ -143,5 +146,5 @@
 	close_button.addActionListener(owner);
 	close_button.addActionListener(this);
-	close_button.setMinimumSize(Utility.MINIMUM_BUTTON_SIZE);
+	close_button.setMinimumSize(MINIMUM_BUTTON_SIZE);
 	close_button.setMnemonic(KeyEvent.VK_C);
 	close_button.setEnabled(true);
@@ -238,5 +241,5 @@
 
     public Dimension getPreferredSize() {
-	return Utility.PROGRESS_BAR_SIZE;
+	return PROGRESS_BAR_SIZE;
     }
 
Index: /trunk/gli/src/org/greenstone/gatherer/util/Utility.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/util/Utility.java	(revision 10007)
+++ /trunk/gli/src/org/greenstone/gatherer/util/Utility.java	(revision 10008)
@@ -60,14 +60,8 @@
  * @version 2.3b
  */
-public class Utility {
-    static final public Dimension MINIMUM_BUTTON_SIZE = new Dimension(100, 25);
-    // static final public Dimension DOUBLE_IMAGE_BUTTON_SIZE = new Dimension(190, 35);
-    static final public Dimension LABEL_SIZE = new Dimension(150, 25);
-    /** The default size of a gatherer progress bar, in either the download view or the build view. */
-    static final public Dimension PROGRESS_BAR_SIZE = new Dimension(580,65);
-    /** The number of kilobytes to use as a io buffer. */
-    static final public int FACTOR = 1;
-    /** The size of the io buffer, calculated as FACTOR * 1024. */
-    static final public int BUFFER_SIZE = FACTOR * 1024;
+public class Utility
+{
+    /** The size of the io buffer, in bytes. */
+    static final public int BUFFER_SIZE = 1024;
     /** Definition of an important directory name, in this case the base dir, or the working directory of the Gatherer. */
 