Index: /trunk/gsdl/etc/main.cfg
===================================================================
--- /trunk/gsdl/etc/main.cfg	(revision 10030)
+++ /trunk/gsdl/etc/main.cfg	(revision 10031)
@@ -83,5 +83,5 @@
                 document.dm browse.dm status.dm authen.dm users.dm html.dm \
                 extlink.dm gsdl.dm extra.dm home.dm collect.dm docs.dm \
-		bsummary.dm translang.dm  garish.dm gli.dm \
+		bsummary.dm gti.dm garish.dm gli.dm \
 		english.dm english2.dm french.dm french2.dm spanish.dm \
 		spanish2.dm russian.dm russian2.dm
Index: /trunk/gsdl/macros/english2.dm
===================================================================
--- /trunk/gsdl/macros/english2.dm	(revision 10030)
+++ /trunk/gsdl/macros/english2.dm	(revision 10031)
@@ -1125,6 +1125,6 @@
 
 ######################################################################
-# 'translator' pages
-package translang
+# GTI text strings
+package gti
 ######################################################################
 
@@ -1134,15 +1134,9 @@
 #------------------------------------------------------------
 	
-_texttranslator_ {The Translator}
-
-_texttranshead_ {
-<strong><br></center><a href=\"_gwcgi_?e=_compressedoptions_&a=lang&p=translang\">
-<img src=\"_httpimg_/tranhead.gif\"></a>
-<center><p>
-<img src="_httpimg_/divb.gif"></strong><p>
-}
-
-_textinitial_ {
-</center>
+_textgti_ {The Greenstone Translator Interface}
+
+_textgtierror_ {An error has occurred}
+
+_textgtihome_ {
 These pages help you improve Greenstone's foreign language support. Using them, you can
 <ul>
@@ -1165,39 +1159,40 @@
 translation will be provided and you should check and update this if necessary.
 <p>
-Each page ends with a "_textnext_" button. When you press it, changes are
+Each page ends with a "_textgtisubmit_" button. When you press it, changes are
 made immediately to a separate Greenstone installation at nzdl.org. A button
 is provided on each page to access this site.
-<p>
-<center>
-}
-
-#_textselectbase_ {Please select a base language from which to translate:}
-_textselectforeign_ {Please select the language you are translating into:}
-_textselectfiletotranslate_ {Please select a file to translate:}
-
-_texttranslatecoredm_ {Core Macrofile}
-_texttranslateauxdm_ {Auxiliary Macrofile}
-_texttranslateglidict_ {GLI Dictionary}
-
-_textenter_ {ENTER}
-
-_textchoosedifferent_ {Please choose different source and target languages!}
-
-_textpage_ {Page}
-_textof_ {of}
-
-_textnext_ {NEXT}
-_textnextwarning_ {
-Pressing "_textnext_" will record all non-blank fields as translations.<br>
-If you do not wish to do this, first press }
-_textresetform_ {RESET FORM}
-
-_textthanks_ {Thank you for updating the}
-_texttrans_ {translation.<br>The file is now part of the Greenstone system and
- will be included in future releases.}
-
-# _textgetdmfiles_ {You can download the macro files you have created}
-# _textviewtranslation_ {Your changes will immediately be reflected}
-# _texthere_ {here}
+}
+
+_textgtiselecttlc_ {Please select your language}
+
+_textgtiselecttfk_ {Please select a file to work on}
+
+_textgticoredm_ {Core Macrofile}
+_textgtiauxdm_ {Auxiliary Macrofile}
+_textgtiglidict_ {GLI Dictionary}
+_textgtiperlmodules_ {Perl Modules}
+_textgtigreenorg_ {Greenstone.org}
+
+_textgticorrectexistingtranslations_ {Correct existing translations}
+_textgtienter_ {ENTER}
+
+_textgtinumchunksmatchingquery_ {Number of text fragments matching the query}
+
+_textgtinumchunkstranslated_ {translations done}
+_textgtinumchunksrequiringupdating_ {Of these, _1_ require updating}
+_textgtinumchunksrequiringtranslation_ {translations remaining}
+_textgtidownloadtargetfile_ {Download file}
+
+_textgtienterquery_ {Enter a word or phrase from the text fragment you want to correct}
+_textgtifind_ {FIND}
+
+_textgtitranslatingchunk_ {Translating text fragment <i>_1_</i>}
+_textgtiupdatingchunk_ {Updating text fragment <i>_1_</i>}
+_textgtisubmit_ {SUBMIT}
+
+_textgtilastupdated_ {Last updated}
+
+_textgtitranslationfilecomplete_ {Thank you for updating this file -- it is now complete!<p>You can download a copy of this file using the link above, and it will also be included in future releases of Greenstone.}
+
 
 ############
Index: /trunk/gsdl/macros/gti.dm
===================================================================
--- /trunk/gsdl/macros/gti.dm	(revision 10031)
+++ /trunk/gsdl/macros/gti.dm	(revision 10031)
@@ -0,0 +1,197 @@
+# this file must be UTF-8 encoded
+package gti
+
+#######################################################################
+# page content
+#######################################################################
+
+_content_ {
+<a href="_gwcgi_?a=gti&p=home&e=_compressedoptions_"><img src="_httpimg_/gti.gif"></a>
+<p>
+<img src="_httpimg_/divb.gif">
+<p>
+<form method="post" action="_gwcgi_" accept-charset="UTF-8">
+  <input type="hidden" name="a" value="gti"/>
+  <input type="hidden" name="e" value="_compressedoptions_">
+  _gtiformcontent_
+</form>
+<p>
+<img src="_httpimg_/divb.gif">
+<p>
+}
+
+# Content of the GTI "error" page
+_gtierror_ {
+<strong>_textgtierror_:</strong>
+<p>
+<tt>_gtierrormessage_</tt>
+}
+
+# Content of the GTI "home" page
+_gtihome_ {
+_textgtihome_
+<p>
+<table border="0" width="100%">
+  <td>_textgtiselecttlc_:</td><td align="right">_gtitlcselection_</td>
+</table>
+<p>
+<center>
+  <input type="hidden" name="p" value="lang"/><input type="submit" value="_textgtienter_"/>
+</center>
+}
+
+# Content of the GTI "language status" page
+_gtilang_ {
+<h2>_gtitargetlanguagename_</h2>
+<p>
+_textgtiselecttfk_:
+<p>
+_gtitfkselection_
+<p>
+<center>
+  <input type="hidden" name="p" value="core"/><input type="submit" value="_textgtienter_"/>
+</center>
+}
+
+# Content of the GTI "find text fragments" page
+_gtifind_ {
+<h2><a href="_gwcgi_?a=gti&p=lang&e=_compressedoptions_">_gtitargetlanguagename_</a> -- <a href="_gwcgi_?a=gti&p=core&e=_compressedoptions_">_gtitranslationfiledesc_</a></h2>
+<p>
+_textgtienterquery_:
+<p>
+<nobr>
+<input type="text" name="q" value="_cgiargq_" size="_gtitextareawidth_"/>
+<input type="hidden" name="p" value="find"/><input type="submit" value="_textgtifind_"/>
+</nobr>
+_gtifindformcontent_
+}
+
+# Content of the GTI "core" page (with text areas for entering and updating translations)
+_gticore_ {
+<h2><a href="_gwcgi_?a=gti&p=lang&e=_compressedoptions_">_gtitargetlanguagename_</a> -- _gtitranslationfiledesc_</h2>
+<p>
+<center>
+  _gtitranslationfilestatus_(_gtinumchunkstranslated_, _gtinumchunksrequiringtranslation_, _gtinumchunksrequiringupdating_, _gtitargetfilepath_)
+</center>
+<p>
+_gticoreformcontent_
+<p>
+<center>
+  <input type="hidden" name="p" value="submit"/><input type="submit" value="_textgtisubmit_"/>
+</center>
+}
+
+# Content of the GTI "done" page, thanking the translation for completing the file
+_gtidone_ {
+<h2><a href="_gwcgi_?a=gti&p=lang&e=_compressedoptions_">_gtitargetlanguagename_</a> -- _gtitranslationfiledesc_</h2>
+<p>
+<center>
+  _gtitranslationfilestatus_(_gtinumchunkstranslated_, _gtinumchunksrequiringtranslation_, _gtinumchunksrequiringupdating_, _gtitargetfilepath_)
+</center>
+<p>
+<hr>
+<p>
+_textgtitranslationfilecomplete_
+}
+
+_gtifindformheader_ {
+<hr><p>_textgtinumchunksmatchingquery_: _gtinumchunksmatchingquery_
+}
+
+_gtifindformfooter_ {
+<p>
+<center>
+  <input type="submit" name="sp" value="_textgtisubmit_"/>
+</center>
+}
+
+_gtitextareawidth_ {70}
+
+# --------------------------------------------------------------------------------
+#   Displays the status of a translation file
+#
+#   Used on the GTI "lang" and "core" pages
+#
+#   Parameters: 1 -- Number of chunks translated
+#               2 -- Number of chunks requiring translation
+#               3 -- Number of chunks requiring updating
+#		4 -- Relative URL of target file
+# --------------------------------------------------------------------------------
+_gtitranslationfilestatus_ {
+<table border="0">
+  <tr><td align="right">_1_</td><td>_textgtinumchunkstranslated_ (_textgtinumchunksrequiringupdating_(_3_))</td></tr>
+  <tr><td align="right">_2_</td><td>_textgtinumchunksrequiringtranslation_</td></tr>
+  _If_(_4_,<tr><td align="right">&nbsp;</td><td><a href="_gwcgi_?a=gti&p=find&e=_compressedoptions_">_textgticorrectexistingtranslations_</a><br><a href="_httpprefix_/_4_">_textgtidownloadtargetfile_</a></td></tr>)
+</table>
+}
+
+# --------------------------------------------------------------------------------
+#   Displays text area for correcting a chunk
+#
+#   Used on the GTI "find" page
+#
+#   Parameters: 1 -- Chunk key
+#               2 -- Target file chunk text
+# --------------------------------------------------------------------------------
+_gtichunkmatchingquery_ {
+<p>
+<center>
+  <table>
+    <tr><td><strong>_1_</strong></td></tr>
+    <tr><td><textarea name="_cgiargtlc_::_1_" rows="4" cols="_gtitextareawidth_">_2_</textarea></td></tr>
+  </table>
+</center>
+}
+
+# --------------------------------------------------------------------------------
+#   Displays text areas for translating a chunk
+#
+#   Used on the GTI "core" page
+#
+#   Parameters: 1 -- Chunk key
+#               2 -- Source file chunk text
+#               3 -- Source file chunk date
+# --------------------------------------------------------------------------------
+_gtichunkrequiringtranslation_ {
+<hr>
+_textgtitranslatingchunk_(_1_)
+<p>
+<center>
+  <table>
+    <tr><td><strong>English</strong></td><td align="right"><font size="-1"><i>_textgtilastupdated_ _3_</i></font></td></tr>
+    <tr><td colspan="2"><textarea name="en::_1_" rows="4" cols="_gtitextareawidth_" readonly="1">_2_</textarea></td></tr>
+  </table>
+  <table>
+    <tr><td><strong>_gtitargetlanguagename_</strong></td><td align="right">&nbsp;</td></tr>
+    <tr><td colspan="2"><textarea name="_cgiargtlc_::_1_" rows="4" cols="_gtitextareawidth_"></textarea></td></tr>
+  </table>
+</center>
+}
+
+# --------------------------------------------------------------------------------
+#   Displays text areas for updating a chunk
+#
+#   Used on the GTI "core" page
+#
+#   Parameters: 1 -- Chunk key
+#               2 -- Source file chunk text
+#               3 -- Source file chunk date
+#               4 -- Target file chunk text
+#               5 -- Target file chunk date
+# --------------------------------------------------------------------------------
+_gtichunkrequiringupdating_ {
+<hr>
+_textgtiupdatingchunk_(_1_)
+<p>
+<center>
+  <table>
+    <tr><td><strong>English</strong></td><td align="right"><font size="-1"><i>_textgtilastupdated_ _3_</i></font></td></tr>
+    <tr><td colspan="2"><textarea name="en::_1_" rows="4" cols="_gtitextareawidth_" readonly="1">_2_</textarea></td></tr>
+  </table>
+  <p>
+  <table>
+    <tr><td><strong>_gtitargetlanguagename_</strong></td><td align="right"><font size="-1"><i>_textgtilastupdated_ _5_</i></font></td></tr>
+    <tr><td colspan="2"><textarea name="_cgiargtlc_::_1_" rows="4" cols="_gtitextareawidth_">_4_</textarea></td></tr>
+  </table>
+</center>
+}
Index: unk/gsdl/macros/translang.dm
===================================================================
--- /trunk/gsdl/macros/translang.dm	(revision 10030)
+++ 	(revision )
@@ -1,105 +1,0 @@
-# this file must be UTF-8 encoded
-package translang
-
-#######################################################################
-# page content
-#######################################################################
-	
-_pagetitle_ {_collectionname_}
-_pagescriptextra_ {}
-_pagebannerextra_ {}
-_pagefooterextra_ {}
-
-_header_ {_cgihead_
-_htmlhead_(background="_httpiconchalk_")_startspacer__optnavigationbar_
-
-}
-
-_header_[v=1] {_cgihead_
-_htmlhead__optnavigationbar_
-
-}
-	
-_cgihead_{}
-
-_htmlhead_ {
-<html_htmlextra_>
-<head>
-<title>_pagetitle_</title>
-_globalscripts_
-</head>
-
-<body bgcolor="\#ffffff" text="\#000000" link="\#006666" 
-      alink="\#cc9900" vlink="\#666633"_1_>
-<font face="Arial,Verdana">
-
-}
-
-# _startspacer_ is a spacer to get past the 10010 graphic. It contains an open
-# <table> tag which must eventually be closed by _endspacer_.
-_startspacer_ {
-<table border=0 cellspacing=0 cellpadding=0 width="100%">
-<tr><td valign=top width=65><img src="_httpimg_/spacer.gif" width="65" height="1" alt="" border="0"></td>
-<td><center><table width="_pagewidth_"><tr><td>
-}
-
-
-
-_footer_ {
-<!-- page footer (\_style:footer\_) -->
-_pagefooterextra_
-</font>
-</table>
-_endspacer__htmlfooter_
-}
-
-_endspacer_ {</center>
-</td></tr></table>
-}
-
-_htmlfooter_ {
-</body>
-</html>
-}
-
-_globalscripts_{
-<script>
-<!--
-_imagescript_
-_pagescriptextra_
-// -->
-</script>
-}
-
-_globalscripts_ [v=1] {
-<script>
-<!--
-_If_(_cgiargx_,_scriptdetach_)
-_pagescriptextra_
-// -->
-</script>
-}
-
-_scriptdetach_ {
-    function close\_detach() \{
-	close();
-    \}
-}
-
-
-#EVERYTHING ABOVE THIS LINE IS A DIRECT COPY FROM STYLE.DM
-#should be able to remove?
-
-_content_ {
-<form method="post" action="_formaction_" accept-charset="UTF-8">
-_formcontent_
-</form>
-}
-
-_imageserch_ { _gsimage_(_gwcgi_?e=_compressedoptions_&a=p&p=query&c=macrop&bl=_cgiargbl_&tlng=_cgiargtlng_,
-	 _httpimg_/search.gif, _httpimg_/search.gif, search, _textimageserch_)}
-
-# THINK SHOULD BE USING S.T LIKE THIS ABOVE COS COMPRESSED ARGS CAN CHANGE!
-# _httppagex_(search)
-
-_textimageserch_ {Search Macrofiles}