Index: trunk/gli/src/org/greenstone/gatherer/util/Utility.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/util/Utility.java	(revision 10208)
+++ trunk/gli/src/org/greenstone/gatherer/util/Utility.java	(revision 10214)
@@ -125,5 +125,9 @@
 	
 
-    /** It turns out that in Java you have to make sure a directory is empty before you delete it (much like unix I suppose), and so just like unix I'll have to set up a recursive delete function.
+    /**
+     * Delete a file or directory
+     * It turns out that in Java you have to make sure a directory is empty before you delete it (much like unix I suppose),
+     * and so just like unix I'll have to set up a recursive delete function.
+     *
      * @param file The <strong>File</strong> you want to delete.
      * @return A <i>boolean</i> which is <i>true</i> if the file specified was successfully deleted, <i>false</i> otherwise.
@@ -439,8 +443,9 @@
 
 
-    /** Method which unzips a given metadata resoure
-     * @param zip_fname The name of the zip file as a <strong>String</strong>.
+    /** 
+     * Method which unzips a given metadata resoure.
+     * @param jar_zip_fname The name of the jar file as a <strong>String</strong>.
      * @param dst_dir The destination directory for unzipping, also as a <strong>String</strong>.
-     * @param use_classloader Used to determine whether or not to look in resource bundle.
+     * @see JarTools.extractFromJar(String, String, boolean)
      */
     static public void unzipFromJar(String jar_zip_fname, String dst_dir) {
@@ -512,20 +517,21 @@
     }
 
-    /*
-      Method to handle zipping up of a file. Called by zipup and dirFunc.
-
-      @param zos the zip output stream, as a <strong>ZipOutputStream</strong>
-      @param file_path the <strong>String</strong> containing the path to the file/directory tozip up
-      @param prefix_strip the <strong>int</strong> used to substring the file_path
-      @param source the <strong>GShell</strong> that is calling this method, so that we can check to see if the process has been cancelled. null if GShell is not the calling object.
-      @param accept_expr a <strong>String</strong> containing a regular expression of files to include in the archive. All other files will be excluded.
-      @param reject_expr a <strong>String</strong> containing a regular expression of files not to include in the archive.
-
-      @return boolean
-
-      @see dirFunc
-      @see zipup
-     */
-    static protected boolean zipFunc (ZipOutputStream zos, String file_path, int prefix_strip, GShell source, boolean encountered_file, String accept_expr, String reject_expr) 
+    /**
+     * Method to handle zipping up of a file (not a directory).
+     * Called by {@link zipup(String, String, String, GShell, String, String)} and {@link dirFunc(ZipOutputStream, String, int, GShell, boolean, String, String)}
+     *
+     * @param zos the zip output stream, as a <strong>ZipOutputStream</strong>
+     * @param file_path the <strong>String</strong> containing the path to the file/directory tozip up
+     * @param prefix_strip the <strong>int</strong> used to substring the file_path
+     * @param source the <strong>GShell</strong> object that is calling this method, so that we can check to see if the process has been cancelled.
+     *               This is null if GShell is not the calling object.
+     * @param accept_expr a <strong>String</strong> containing a regular expression of files to include in the archive. All other files will be excluded.
+     *                    There is a special case of ".*doc.xml", where the doc.xml files will be parsed to only include their metadata.
+     * @param reject_expr a <strong>String</strong> containing a regular expression of files not to include in the archive.
+     * @return boolean - true if the zip was created successfully(?).
+     * @see dirFunc(ZipOutputStream, String, int, GShell, boolean, String, String) 
+     * @see zipup(String, String, String, GShell, String, String)
+     */
+    static protected boolean zipFunc(ZipOutputStream zos, String file_path, int prefix_strip, GShell source, boolean encountered_file, String accept_expr, String reject_expr) 
     {
 	String new_file_path = file_path;
@@ -609,17 +615,18 @@
     }
 
-    /*
-      Method to handle ziping up of a directory.
-
-      @param zos
-      @param dir_name
-      @param prefix_strip
-      @param source
-      @param encountered_file ??What's this??
-      @param accept_expr
-      @param reject_expr
-
-      @see zipup
-      @see zipFunc
+    /**
+     * Method to handle ziping up of a directory. This is called by {@link zipup(String, String, String, GShell, String, String)}
+     *
+     * @param zos the <strong>ZipOutputStream</strong> to output to.
+     * @param dir_name the directory name to zip, as a <strong>String</strong>
+     * @param prefix_strip the <strong>int</strong> used to substring the file_path
+     * @param source the <strong>GShell</strong> object that is calling this method, so that we can check to see if the process has been cancelled.
+     *               This is null if GShell is not the calling object.
+     * @param encountered_file ??What's this??
+     * @param accept_expr a <strong>String</strong> containing a regular expression of files to include in the archive. All other files will be excluded.
+     * @param reject_expr a <strong>String</strong> containing a regular expression of files not to include in the archive.
+     *
+     * @see zipup(String, String, String, GShell, String, String)
+     * @see zipFunc(ZipOutputStream, String, int, GShell, boolean, String, String) 
      */
     static protected boolean dirFunc (ZipOutputStream zos, String dir_name, int prefix_strip, GShell source, boolean encountered_file, String accept_expr, String reject_expr) 
@@ -670,14 +677,20 @@
     
     /**
-      Method to zip up a given file or directory
-
-      @param col_dir
-      @param col_name
-      @param dir_or_file
-      @param source
-      @param filter
-
-      @see zipFunc
-      @see dirFunc
+     * Method to zip up a given file or directory associated with a particular collection.
+     * This method mainly called from {@link GShell}, with a few exceptions. The zip files produced are used
+     * to pass files (new files to add, metadata, etc) between the GLI applet and the Greenstone server.
+     * The actual zipping of files and directories is handled by {@link zipFunc(ZipOutputStream, String, int, GShell, boolean, String, String) and
+     * {@link dirFunc(ZipOutputStream, String, int, GShell, boolean, String, String)} respectfully.
+     *
+     * @param col_dir the path to the collect directory, as a <strong>String</strong>
+     * @param col_name the collection name, as as <strong>String</strong>
+     * @param dir_or_file the directory or file within the collection to zip up, as a <strong>String</strong>
+     * @param source the <strong>GShell</strong> object that is calling this method, so that we can check to see if the process has been cancelled.
+     *               This is null if GShell is not the calling object.
+     * @param accept_expr a <strong>String</strong> containing a regular expression of files to include in the archive. All other files will be excluded.
+     * @param reject_expr a <strong>String</strong> containing a regular expression of files not to include in the archive.
+     *
+     * @see zipFunc(ZipOutputStream, String, int, GShell, boolean, String, String) 
+     * @see dirFunc(ZipOutputStream, String, int, GShell, boolean, String, String) 
      */
     static public boolean zipup(String col_dir, String col_name, String dir_or_file, GShell source, String accept_expr, String reject_expr)
@@ -689,5 +702,5 @@
 	int prefix_strip = col_dir.length();
 	boolean encountered_file = false;
-	
+
 	String zip_fname = col_dir + col_name + ".zip";
 	String zip_dir_or_file = col_dir + col_name + File.separator + dir_or_file;
@@ -738,5 +751,11 @@
     } 
     
-
+    /**
+     * Method to unzip a zip file associated with a particular collection.
+     * The location and name of the zip file should be derrived from the collection. Please see below for details.
+     *
+     * @param col_dir the path to the collection directory, as a <strong>String</strong>. This is where the zip file should be located.
+     * @param col_name the name of the collection, as a <strong>String</strong>. This should be the name of the zip file (with a  .zip extension).
+     */
     static public void unzip(String col_dir, String col_name)
     {
@@ -751,6 +770,4 @@
 	try {
 	    File cfile = new File(zip_fname);
-	    System.err.println("**** zip fname = " + cfile.toString());
-
 	    ZipFile zipfile = new ZipFile(cfile, zip_mode);
 	    
Index: trunk/gli/src/org/greenstone/gatherer/util/Zipup.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/util/Zipup.java	(revision 10208)
+++ trunk/gli/src/org/greenstone/gatherer/util/Zipup.java	(revision 10214)
@@ -40,15 +40,17 @@
 import java.io.File;
 
-/*
-  Class to zip up a given directory of a given Greenstone collection.
-
-  Arguments:
-  gsdlhome, the home of greensone, eg "/research/mgw5/gsdl/"
-  collecion, thename of the collection, eg "mgw5-test"
-  dir, the name of the directory to zip up, eg "archives"
-  [accept_expression], a regular expression of files to exclusively include in the archive
-  [reject_expression], a regular expression of files to exclude from the archive
-
-  @see org.greenstone.gatherer.util.Utility#zipup
+/**
+ * Zip up a given directory of a given Greenstone collection.
+ * The actual zipping code is contained in {@link Utility.zipup(String, String, String, GShell, String, String)}.
+ * This class basically contains a main method that requires adequate arguments to call the zipup method.
+ *
+ * Arguments:
+ * <br>gsdlhome, the home of greensone, eg "/research/mgw5/gsdl/"
+ * <br>collecion, the name of the collection, eg "mgw5-test"
+ * <br>directory, the name of the directory to zip up, eg "archives"
+ * <br>[accept_expression], a regular expression of files to exclusively include in the archive. Optional.
+ * <br>[reject_expression], a regular expression of files to exclude from the archive. Optional.
+ *
+ * @see Utility.zipup(String, String, String, GShell, String, String)
  */
 public class Zipup {